function unew = multigrid(A, b, ul, l, nu, nu1, alpha, cflval)
 
dtsmooth = cflval*2^(3-l);

for i=1:nu1,
    ul = runge_kutta_smoother(A, b, ul, dtsmooth, alpha);
end
error = zeros(length(ul),1);
if (l>1)
  r=b-A*ul;
  rlow = restriction(r);
  ulow = zeros(length(ul)/2,1);
%  Restrict A and b
  dim=length(ul)/2;
  dx=2/dim;
  A = (1+nu/dx)*speye(dim) - nu/dx* spdiags(ones(dim - 1,1),-1,dim,dim);
  A(1,dim)=- nu/dx;
  errorlow = multigrid(A, rlow, ulow, l-1, nu, nu1, alpha, cflval);
  error = prolongation(errorlow);
end
unew = ul + error;
