%Variables definition
clear all
format long
ibase=200
jbase=200
jdim=1*jbase
kbase=200
avec=zeros(ibase,1);
cvec=zeros(jdim,1);
%Generate grid
for i=1:ibase
  avec(i)=i/ibase;
end
for j=1:jdim
  cvec(j)=j/jbase;
end

dxovernu=1./24.;

for i=1:ibase
  a=avec(i);
  for j=1:jdim
    c=cvec(j);
    for k=0:kbase
      t=k/kbase*pi/2.+pi/2.;
      realz=-c*dxovernu-c+c*cos(t);
      imz=-sin(t)*c;
      A(i,j,k+1)=(a*realz^2-a*imz^2+realz+1)^2+(2*a*realz*imz+imz)^2;
    end
  end
end

%Compute maxima for given alpha and dt over theta
for i=1:ibase
  for j=1:jdim
    maxvec((i-1)*jdim+j) = max(A(i,j,:));
    Amat(i,j) = maxvec((i-1)*jdim+j);
  end
end

%Compute minima over alpha und dt for max over theta
[result resultindex]= min(maxvec)
alphaoptindex=ceil(resultindex/jdim)
alphaopt = alphaoptindex/ibase
coptindex = resultindex-(alphaoptindex-1)*(jdim)
copt = coptindex/jbase
  
%meshc(avec, cvec,log(Amat))
[C, h]=contour(avec, cvec, log(Amat'));
set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2)
xlabel('\alpha')
ylabel('c')
grid on
