#include <cstdio>
#include <cstring>
#include <cmath>
#include <fstream>

int main(int argc, char **argv){
  long ibase, bbase, jbase, jdim, kbase;
  double dxovernu, a1, b, c, dx, nu;
  double t, realz, imz;
  double a, a1opt, a2opt, copt, result, maxvalue;
  long a1optind, a2optind, coptind, resultind;
  double pi=3.1415926535898;
  std::ofstream outrks("optrk3.txt");
  ibase=200;
  bbase=200;
  jbase=200;
  jdim=2*jbase;
  kbase=200;
  dxovernu=1./24.;

  double avec[ibase];
  double bvec[bbase];
  double cvec[jdim];
  double testvec[kbase];
  double kvec[kbase+1];
  double* maxvec=new double[ibase*jdim*bbase];

//Generate grid
  for (size_t i=0; i<ibase; i++)
    avec[i]=(double) (i+1)/ibase;
  for (size_t i=0; i<bbase; i++)
    bvec[i]=(double) (i+1)/bbase;
  for (size_t i=0; i<jdim; i++)
    cvec[i]=(double) (i+1)/jbase;
  for (size_t i=0; i<(kbase+1); i++)
    kvec[i]=(double) i/kbase;

  for (size_t i=0; i<ibase; i++){
    a=avec[i];
    for (size_t l=0; l<bbase; l++){
      a1=bvec[l];
      b=a1*a;
      for (size_t j=0; j<jdim; j++){
	c=cvec[j];
	maxvalue=-1.;
	for (size_t k=0; k<(kbase+1); k++){
	  t=kvec[k]*pi/2.+pi/2.;
	  realz=-c*dxovernu-c+c*cos(t);
	  imz=-c*sin(t);
	  testvec[k]=(1.+realz+a*realz*realz-a*imz*imz+b*realz*realz*realz-3.*b*realz*imz*imz)*(1.+realz+a*realz*realz-a*imz*imz+b*realz*realz*realz-3.*b*realz*imz*imz);
	  testvec[k]+=(imz+2.*a*realz*imz-b*imz*imz*imz+3.*b*realz*realz*imz)*(imz+2.*a*realz*imz-b*imz*imz*imz+3.*b*realz*realz*imz);
	  if (testvec[k]>maxvalue)
	    maxvalue=testvec[k];
	}
	//Compute maxima for given alpha and dt over theta
	maxvec[i*jdim*bbase+l*jdim+j] = maxvalue;
      }
    }
  }
  
  //Compute minima over alpha und dt for max over theta
  result=maxvec[0];
  resultind=1;
  for (size_t i=1; i<ibase*jdim*bbase; i++){
    if (maxvec[i]<result){
      result=maxvec[i];
      resultind=i+1;
    } 
  }
  a2optind=ceil((double) resultind/(jdim*bbase));
  a2opt = (double) a2optind/ibase;
  a1optind= ceil((double) (resultind - (a2optind-1)*jdim*bbase)/jdim);
  a1opt = (double) a1optind/bbase;
  coptind = resultind-(a2optind-1)*jdim*bbase - (a1optind-1)*jdim;
  copt = (double) coptind/jbase;
 
  outrks << "result=" << result << std::endl;
  outrks << "resultind=" << resultind << std::endl;
  outrks << "a1opt=" << a1opt << std::endl;
  outrks << "a1optind=" << a1optind << std::endl;
  outrks << "a2opt=" << a2opt << std::endl;
  outrks << "a2optind=" << a2optind << std::endl;
  outrks << "copt=" << copt << std::endl;
  outrks << "coptind=" << coptind << std::endl;
 
  delete maxvec;

  return 0;
}
