#include <cstdio>
#include <cmath>
#include <cmath>
#include <fstream>

int main(){
  int abase, bbase, cbase, cflbase, cfldim, kbase;
  double dxovernu, a, a2, a3, b, c;
  double t, realz, imz, cfl, maxvalue;
  double a1opt, a2opt, a3opt, cflopt, result;
  int a1optind, a2optind, a3optind, cfloptind;
  long prod, resultind;
  double pi=3.1415926535898;
  std::ofstream outrks("optrk4.txt");

  abase=150;
  bbase=150;
  cbase=150;
  cflbase=150;
  cfldim=2*cflbase;
  kbase=100;
  dxovernu=1./9.;
  prod=abase*bbase*cbase*cfldim;
  
  double* avec=new double[abase];
  double* bvec=new double[bbase];
  double* cvec=new double[cbase];
  double* cflvec=new double[cfldim];
  double* testvec=new double[kbase];
  double* kvec=new double[kbase+1];
  double* maxvec=new double[prod];
  double* tvec=new double[kbase+1];
  double* cosvec=new double[kbase+1];
  double* sinvec=new double[kbase+1];

//Generate grid
  for (size_t i=0; i<abase; i++)
    avec[i]=(double) (i+1)/abase;
  for (size_t i=0; i<bbase; i++)
    bvec[i]=(double) (i+1)/bbase;
  for (size_t i=0; i<cbase; i++)
    cvec[i]=(double) (i+1)/cbase;
  for (size_t i=0; i<cfldim; i++)
    cflvec[i]=(double) (i+1)/cflbase;
  for (size_t i=0; i<(kbase+1); i++){
    kvec[i]=(double) i/kbase;
    tvec[i]=kvec[i]*pi/2.+pi/2.; 
    cosvec[i]=cos(tvec[i]);
    sinvec[i]=sin(tvec[i]);
  }

  for (size_t i=0; i<abase; i++){
    a=avec[i];
    for (size_t l=0; l<bbase; l++){
      a2=bvec[l];
      b=a*a2;
      for (size_t m=0; m<cbase; m++){
	a3=cvec[m];
	c=a3*a2*a;
	for (size_t j=0; j<cfldim; j++){
	  cfl=cflvec[j];
	  maxvalue=-1.;
	  for (size_t k=0; k<(kbase+1); k++){
	    t=tvec[k];
	    realz=-cfl*dxovernu-cfl+cfl*cosvec[k];
	    imz=-cfl*sinvec[k];
	    testvec[k]=(1.+realz+a*realz*realz-a*imz*imz+b*realz*realz*realz-3.*b*realz*imz*imz+c*realz*realz*realz*realz-6.*c*realz*realz*imz*imz+c*imz*imz*imz*imz)*(1.+realz+a*realz*realz-a*imz*imz+b*realz*realz*realz-3.*b*realz*imz*imz+c*realz*realz*realz*realz-6.*c*realz*realz*imz*imz+c*imz*imz*imz*imz);
	    testvec[k]+=(imz+2.*a*realz*imz+3.*b*realz*realz*imz-b*imz*imz*imz+4.*c*realz*realz*realz*imz-4.*c*realz*imz*imz*imz)*(imz+2.*a*realz*imz+3.*b*realz*realz*imz-b*imz*imz*imz+4.*c*realz*realz*realz*imz-4.*c*realz*imz*imz*imz);
	    if (testvec[k]>maxvalue)
	      maxvalue=testvec[k];
	  }
	  //Compute maxima for given alpha and dt over theta
	  maxvec[i*cfldim*cbase*bbase+l*cfldim*cbase+m*cfldim+j] = maxvalue;
	}
      }
    }
  }
  
  //Compute minima over alpha und dt for max over theta
  result=maxvec[0];
  resultind=1;
  for (size_t i=1; i<abase*bbase*cbase*cfldim; i++){
    if (maxvec[i]<result){
      result=maxvec[i];
      resultind=i+1;
    } 
  }
  a3optind=ceil((double) resultind/(cfldim*cbase*bbase));
  a3opt = (double) a3optind/abase;
  a2optind= ceil((double) (resultind - (a3optind-1)*cfldim*cbase*bbase)/(cfldim*cbase));
  a2opt = (double) a2optind/bbase;
  a1optind = ceil((double) (resultind-(a3optind-1)*cfldim*cbase*bbase - (a2optind-1)*cfldim*cbase)/cfldim);
  a1opt = (double) a1optind/cbase;
  cfloptind = resultind-(a3optind-1)*cfldim*cbase*bbase - (a2optind-1)*cfldim*cbase -(a1optind-1)*cfldim;
  cflopt = (double) cfloptind/cflbase;
  
  outrks << "result=" << result << std::endl;
  outrks << "resultind=" << resultind << std::endl;
  outrks << "a1opt=" << a1opt << std::endl;
  outrks << "a1optind=" << a1optind << std::endl;
  outrks << "a2opt=" << a2opt << std::endl;
  outrks << "a2optind=" << a2optind << std::endl;
  outrks << "a3opt=" << a3opt << std::endl;
  outrks << "a3optind=" << a3optind << std::endl;
  outrks << "cflopt=" << cflopt << std::endl;
  outrks << "cfloptind=" << cfloptind << std::endl;

  delete maxvec;

  return 0;
}
